searchable.searchableinterface

## Class SearchableElement

- java.lang.Object
- - list.listinterface.Element
  - - searchable.searchableinterface.SearchableElement

- Direct Known Subclasses:
    GraphEdge, GraphVertex, JustifiableHeapElement, SearchableElementWithOrdinalKey

      public abstract class SearchableElement
      extends Element

  Prvek vyhledávací struktury. Obsahuje klíč k vyhledávání.

  Popis: Je to abstraktní třída prvku struktury typu Searchable. Její instance musí obsahovat klíč a případně i hodnotu identifikovanou klíčem. Umí porovnávat klíč při vyhledávání.

  Užití: V aplikaci specializujte nejméně jednou třídou, která bude obsahovat klíč a také bude implementovat abstraktní metody. Pro potřeby porovnávání klíčů mezi různými instancemi by měla tato oodvozená třída obsahovat také metodu vracející klíč, např. getKey. Odvozená třída s klíčem pak může být dále specializována - rozšířena o hodnotu identifikovanou klíčem a o metodu např. getValue, která tuto hodnotu zpřístupní aplikaci.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SearchableElement()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract java.lang.String` | `getReadable()` Vrátí čitelný obsah prvku.
    `abstract boolean` | `isMatching(SearchableElement k)` Zjistí, zda v se shoduje s k.
    `abstract boolean` | `isPreceding(SearchableElement k)` Zjistí, zda this předchází k.
    `abstract boolean` | `isSucceeding(SearchableElement k)` Zjistí, zda this následuje za k.
    `abstract SearchableElement` | `makeSentinel()` Vyrobí zarážku.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SearchableElement

          public SearchableElement()

  - ### Method Detail

    - #### makeSentinel

          public abstract SearchableElement makeSentinel()

      Vyrobí zarážku.
      Returns:
        objekt, který se dá použít jako zarážka při hledání

    - #### isPreceding

          public abstract boolean isPreceding(SearchableElement k)

      Zjistí, zda this předchází k.
      Parameters:
        `k` - prvek, který má být porovnán s this
      Returns:
        true když předchází, jinak false

    - #### isSucceeding

          public abstract boolean isSucceeding(SearchableElement k)

      Zjistí, zda this následuje za k.
      Parameters:
        `k` - prvek, který má být porovnán s this
      Returns:
        true když následuje, jinak false

    - #### isMatching

          public abstract boolean isMatching(SearchableElement k)

      Zjistí, zda v se shoduje s k.
      Parameters:
        `k` - prvek, který má být porovnán s this
      Returns:
        true když se shoduje, jinak false

    - #### getReadable

          public abstract java.lang.String getReadable()

      Vrátí čitelný obsah prvku.
      Returns:
        čitelný obsah prvku